/**
 * copyright (c) 2017-2021 厦门风领科技有限公司
 * http://www.fengling.cn/
 * 
 * 行为类（游戏组件继承自该对象）
 * zengbinsi
 * 2020-08-26
 */


// ==============================================================================
// 扩展cc.Node
// ==============================================================================

// 优化getChildByName的性能
cc.Node.prototype.getChildByNameEx = function (name) {
    this.__childCaches = this.__childCaches || {};
    if (this.__childCaches[name] && this.__childCaches[name].getChildByName) {
        return this.__childCaches[name];
    }

    this.__childCaches[name] = this.getChildByName(name);
    return this.__childCaches[name];
};

// // 优化getChildByName的性能
cc.Node.prototype.getComponentEx = function (typeOrClass) {
    this.__componentCaches = this.__componentCaches || {};
    const clsName = typeOrClass.name || typeOrClass || '';
    if (this.__componentCaches[clsName] && this.__componentCaches[clsName].destroy) {
        return this.__componentCaches[clsName];
    }

    this.__componentCaches[clsName] = this.getComponent(typeOrClass);
    return this.__componentCaches[clsName];
};


// ==============================================================================
// 扩展cc.Label
// ==============================================================================
