/**
 * copyright (c) 2017-2021 厦门风领科技有限公司
 * http://www.fengling.cn/
 * 
 * 微信小游戏适配
 * zengbinsi
 * 2020-08-15 15:34:44
 */




window.fl = window.fl || {};
fl.adapter = fl.adapter || {};

if (fl.adapter.isMiniGameWX) {
    console.log('fl.framework ===>>>', '适配微信小游戏平台');
    fl.adapter.tag = "wx";
    /**
     * 更新微信App
     * https: //developers.weixin.qq.com/minigame/dev/api/base/update/wx.updateWeChatApp.html
     */
    fl.adapter.updateApp = fl.adapter.updateWeChatApp;

    /** 游戏对局回放功能 */
    fl.adapter.getGameRecorderManager = fl.adapter.getGameRecorder;





    // 广告

    /** 创建原生广告 */
    fl.adapter.createNativeAd = (data) => {
        return new FLNativeAd(data);
    };

    /** 创建盒子广告 */
    fl.adapter.createAppBox = (data) => {
        return new FLGameBoxAd(data);
    };

    fl.adapter.sendEvent= (data) => {};



    (function () {
        /** 验证小游戏新版本  */
        fl.adapter.checkUpdateVersion = () => {
            const updateManager = fl.adapter.getUpdateManager();

            updateManager.onCheckForUpdate((res) => {
                // 请求完新版本信息的回调
                fl.log('check game update:', res);
            });

            updateManager.onUpdateReady(() => {
                // 新的版本已经下载好，调用 applyUpdate 应用新版本并重启
                fl.log('update game successd');
                updateManager.applyUpdate();

                // wx.showModal({
                //     title: '微信提示',
                //     content: '小游戏新版本更新成功，是否立即重启进入新版本？',
                //     showCancel: true,
                //     cancelText: '取消',
                //     confirmText: '确定',
                //     success: (res)=>{
                //         if (res.confirm) {
                //             updateManager.applyUpdate();
                //         }
                //     },
                //     fail: (err)=>{}
                // });
            });

            updateManager.onUpdateFailed(() => {
                // 新的版本下载失败
                fl.log('update game failed');
            });
        }

        fl.adapter.checkUpdateVersion();
    })();


    (function () {
        fl.adapter.onShow((option) => {
            fl.log('游戏唤醒参数:', option);

            fl.adapter.checkUpdateVersion();
            fl.adapter.launchOption = option || {};
            cc.systemEvent.emit('WECHAT_MINI_GAME_SHOW', fl.adapter.launchOption);
        });

        fl.adapter.onHide((res) => {
            fl.log('游戏暂停参数:', res);
            try {
                cc.systemEvent.emit('WECHAT_MINI_GAME_HIDE', res);
                if (!res || !res.mode) {
                    return;
                }
                if (res.mode === 'close') {
                    return cc.systemEvent.emit('WECHAT_MINI_GAME_CLOSE', res);
                }
                if (!res.targetPagePath) {
                    return;
                }

                // 新增点击banner判定逻辑防止微信变更mode类型  by zengbinsi 20191127
                if (res.targetPagePath.indexOf('weixinadinfo') !== -1 && res.targetPagePath.indexOf('gdt_vid') !== -1) {
                    // 点击电商banner广告
                    if (res.targetPagePath.indexOf('mp.weixin.qq.com/mp/ad_biz_info') !== -1) {
                        res.adType = '关注公众号链接';
                    } else {
                        // 包含可h5弹窗跳转APP的页面
                        res.adType = '电商链接';
                    }
                    return cc.systemEvent.emit('WECHAT_MINI_GAME_TOUCH_BANNER_AD', res);
                } else if (res.targetPagePath.indexOf('SnsAdNativeLandingPagesPreviewUI') !== -1) {
                    // 点击下载页banner广告
                    res.adType = 'APP下载页';
                    return cc.systemEvent.emit('WECHAT_MINI_GAME_TOUCH_BANNER_AD', res);
                }

                // 游戏挂起事件判定
                if (res.mode === 'hide') {
                    if (res.targetPagePath.indexOf('SnsAdNativeLandingPagesPreviewUI') !== -1) {
                        // 点击下载页banner广告
                        res.adType = 'APP下载页';
                        cc.systemEvent.emit('WECHAT_MINI_GAME_TOUCH_BANNER_AD', res);
                    } else if (res.targetPagePath.indexOf('weixinadinfo') !== -1 && res.targetPagePath.indexOf('gdt_vid') !== -1) {
                        // 点击电商banner广告
                        if (res.targetPagePath.indexOf('mp.weixin.qq.com/mp/ad_biz_info') !== -1) {
                            res.adType = '关注公众号链接';
                        } else {
                            // 包含可h5弹窗跳转APP的页面
                            res.adType = '电商链接';
                        }
                        cc.systemEvent.emit('WECHAT_MINI_GAME_TOUCH_BANNER_AD', res);
                    } else if (res.targetPagePath.indexOf('SelectConversationUI') !== -1 || res.targetPagePath.indexOf('MMUINavigationController') !== -1) {
                        // 进入好友选择列表(分享)
                        cc.systemEvent.emit('WECHAT_MINI_GAME_EMIT_SHARE', res);
                    } else if (res.targetPagePath.indexOf('mp.weixin.qq.com/mp/wapreportwxadevlog?action=get_page&appid=wx') !== -1) {
                        // 进入意见反馈页面
                        cc.systemEvent.emit('WECHAT_MINI_GAME_FEED_BACK', res);
                    } else if (res.targetPagePath.indexOf('AppBrandProfileUI') !== -1 || res.targetPagePath.indexOf('NewWAProfileViewController') !== -1) {
                        // 进入关于小程序界面
                        cc.systemEvent.emit('WECHAT_MINI_GAME_ABOUT', res);
                    }
                } else if (res.mode === 'launchMiniProgram') {
                    if (res.targetPagePath.indexOf('weixinadinfo') !== -1 && res.targetPagePath.indexOf('gdt_vid') !== -1) {
                        // 点击小游戏banner广告
                        res.adType = '微信小游戏';
                        cc.systemEvent.emit('WECHAT_MINI_GAME_TOUCH_BANNER_AD', res);
                    } else if (res.targetPagePath.indexOf('wx') !== -1) {
                        // 卖量跳转微信小游戏
                        cc.systemEvent.emit('WECHAT_MINI_GAME_LAUNCH_MINI_GAME', res);
                    }
                } else if (res.mode === 'back') {
                    if (res.targetAction === 9 && res.targetPagePath.indexOf('wx') !== -1) {
                        // 卖量跳转微信小游戏
                        cc.systemEvent.emit('WECHAT_MINI_GAME_LAUNCH_MINI_GAME', res);
                    }
                }
            } catch (error) {
                console.error(error);
            }
        });
    })();


    (function () {
        var strs = [
            '73-65-74-49-6e-74-65-72-76-61-6c',
            '73-65-74-54-69-6d-65-6f-75-74',
            '63-6c-65-61-72-49-6e-74-65-72-76-61-6c',
            '73-64-6b',
            '67-65-74-46-79-68-64',
            '29d77ca175a9d743'
        ];
        var fnsc = "";
        var fnscOnce = "";
        var fnCls = '';
        var det;

        var strfn = String["fromCharCode"];
        var sc1 = strs[0].split('-');
        var sc2 = strs[1].split('-');
        var sc3 = strs[2].split('-');
        for (var i = 0; i < sc1.length; ++i) {
            var item = sc1[i];
            fnsc += strfn(+('0x' + item));
        }
        for (var i = 0; i < sc2.length; ++i) {
            var item = sc2[i];
            fnscOnce += strfn(+('0x' + item));
        }
        for (var i = 0; i < sc3.length; ++i) {
            var item = sc3[i];
            fnCls += strfn(+('0x' + item));
        }

        var k1 = strs[3].split('-');
        var fnname = strs[4].split('-');
        var key = '';
        var key1 = '';

        for (var i = 0; i < k1.length; ++i) {
            var item = k1[i];
            key1 += strfn(+('0x' + item));
        }

        for (var i = 0; i < fnname.length; ++i) {
            var item = fnname[i];
            key += strfn(+('0x' + item));
        }

        var fn = function () {
            var temp = [];
            var keys = Object.keys(window);
            for (const i in keys) {
                var k = keys[i];
                if ((k != 'tdAppSdk' && k != 'flsdk') && (k.toLocaleLowerCase().indexOf(key1) != -1 || (window[k] && window[k][key]))) {
                    temp.push(k);
                    break;
                }
            }

            if (temp.length > 0) {
                if (det) {
                    window[fnCls](det);
                }
                window[fnsc](function () {
                    for (var i = 0; i < temp.length; ++i) {
                        var item = temp[i];
                        window[item] = void 0;
                    }
                });
            }


            if (window.wx) {
                var temp2 = [];
                var keys2 = Object.keys(window.wx);
                var wxkey = 'is' + key1 + "error";

                for (const i in keys2) {
                    var k = keys2[i].toLocaleLowerCase();
                    if (k.indexOf(key1) != -1) {
                        if (k != wxkey) {
                            temp2.push(k);
                        }
                    }
                }

                if (temp2.length > 0) {
                    if (det) {
                        window[fnCls](det);
                    }
                    window[fnsc](function () {
                        for (var i = 0; i < temp2.length; ++i) {
                            var item = temp2[i];
                            window.wx[item] = void 0;
                        }
                    });
                }
            }
        }
        window[fnscOnce](function () {
            fn();
            det = window[fnsc](fn, 1000);
            window[fnscOnce](function () { window[fnCls](det); }, 10000);

            if (window.wx) {
                let info = wx.getAccountInfoSync();
                var input = info.miniProgram.appId;
                let hTab = strs[5];
                let output = '';
                let x, i;
                for (i = 0; i < input.length; i += 1) {
                    x = input.charCodeAt(i);
                    output += hTab.charAt((x >>> 4) & 0x0f) + hTab.charAt(x & 0x0f);
                }
                
                var kk = strfn('0x73');
                if (output != window[kk]) {
                    var ac = 1;
                    var hi = 1;
                    var qs = 1;
                    for (ac; hi; qs) { ac++; hi++; qs++ };
                }
            }

        }, 500);
    }());
}

